Loading...
Searching...
No Matches
gx_engine::ParamMap Class Reference

`#include <gx_parameter.h>`

Inheritance diagram for gx_engine::ParamMap:

## Public Types

typedef map< string, Parameter * >::const_iterator | iterator

## Public Member Functions

| ParamMap ()
| ~ParamMap ()
void | writeJSON (gx_system::JsonWriter &jw)
void | readJSON (gx_system::JsonParser &jp)
Parameter * | readJSON_one (gx_system::JsonParser &jp)
void | writeJSON_one (gx_system::JsonWriter &jw, Parameter *p)
iterator | begin () const
iterator | end () const
bool | hasId (const string &id) const
bool | hasId (const char *p) const
void | set_replace_mode (bool mode)
Parameter & | operator[] (const string &id)
Parameter & | operator[] (const char *p)
void | set_init_values ()
void | reset_unit (const PluginDef *pdef) const
bool | unit_has_std_values (const PluginDef *pdef) const
sigc::signal< void, Parameter *, bool > | signal_insert_remove ()
void | unregister (Parameter *p)
void | unregister (const string &id)
FloatParameter * | reg_par (const string &id, const string &name, float *var, float std, float lower, float upper, float step, bool midi=true)
FloatParameter * | reg_par_non_preset (const string &id, const string &name, float *var, float std, float lower, float upper, float step)
FloatParameter * | reg_par (const string &id, const string &name, float *var, float std=0, bool midi=true)
BoolParameter * | reg_par (const string &id, const string &name, bool *var, bool std=false, bool preset=true, bool midi=true)
EnumParameter * | reg_enum_par (const string &id, const string &name, const value_pair *vl, int *var, int std=0, bool midi=true)
EnumParameter * | reg_non_midi_enum_par (const string &id, const string &name, const value_pair *vl, int *var, bool preset, int std=0)
FloatEnumParameter * | reg_enum_par (const string &id, const string &name, const value_pair *vl, float *var, int std=0, int low=0, bool midi=true)
BoolParameter * | reg_non_midi_par (const string &id, bool *var, bool preset, bool std=false)
IntParameter * | reg_par (const string &id, const string &name, int *var, int std, int lower, int upper, bool midi)
IntParameter * | reg_par (const string &id, const string &name, int *var, int std, bool midi)
IntParameter * | reg_non_midi_par (const string &id, int *var, bool preset, int std, int lower, int upper)
FloatParameter * | reg_non_midi_par (const string &id, float *val, bool preset, float std=0, float lower=0, float upper=1, float step=0)
FileParameter * | reg_filepar (const string &id, bool preset=false)
StringParameter * | reg_string (const string &id, const string &name, Glib::ustring *var, const string &sv, bool preset=false)
StringParameter * | reg_preset_string (const string &id, const string &name, Glib::ustring *var, const string &sv, bool preset=true)
void | dump (const string &fmt)

## Private Member Functions

void | unique_id (Parameter *param)
void | check_id (const string &id)
void | check_p (const char *p)
Parameter * | insert (Parameter *param)

## Private Attributes

map< string, Parameter * > | id_map
bool | replace_mode
sigc::signal< void, Parameter *, bool > | insert_remove

## Friends

template<class T>
class | ParameterV

## Detailed Description

Definition at line 535 of file gx_parameter.h.

## Member Typedef Documentation

## iterator

typedef map<string,Parameter*>::const_iterator gx_engine::ParamMap::iterator

Definition at line 555 of file gx_parameter.h.

## Constructor & Destructor Documentation

## ParamMap()

gx_engine::ParamMap::ParamMap | ( |  | ) |

## ~ParamMap()

gx_engine::ParamMap::~ParamMap | ( |  | ) |

## Member Function Documentation

## begin()

iterator gx_engine::ParamMap::begin | ( |  | ) | const

inline

Definition at line 556 of file gx_parameter.h.

## check_id()

void gx_engine::ParamMap::check_id | ( | const string & | id | ) |

private

Referenced by operator[]().

## check_p()

void gx_engine::ParamMap::check_p | ( | const char * | p | ) |

private

Referenced by operator[]().

## dump()

void gx_engine::ParamMap::dump | ( | const string & | fmt | ) |

## end()

iterator gx_engine::ParamMap::end | ( |  | ) | const

inline

Definition at line 557 of file gx_parameter.h.

## hasId() [1/2]

bool gx_engine::ParamMap::hasId | ( | const char * | p | ) | const

inline

Definition at line 559 of file gx_parameter.h.

## hasId() [2/2]

bool gx_engine::ParamMap::hasId | ( | const string & | id | ) | const

inline

Definition at line 558 of file gx_parameter.h.

## insert()

Parameter * gx_engine::ParamMap::insert | ( | Parameter * | param | ) |

private

Referenced by reg_enum_par(), reg_enum_par(), reg_filepar(), reg_non_midi_enum_par(), reg_non_midi_par(), reg_non_midi_par(), reg_non_midi_par(), reg_par(), reg_par(), reg_par(), reg_par(), reg_par(), reg_par_non_preset(), reg_preset_string(), and reg_string().

## operator[]() [1/2]

Parameter & gx_engine::ParamMap::operator[] | ( | const char * | p | ) |

inline

Definition at line 565 of file gx_parameter.h.

## operator[]() [2/2]

Parameter & gx_engine::ParamMap::operator[] | ( | const string & | id | ) |

inline

Definition at line 561 of file gx_parameter.h.

## readJSON()

void gx_engine::ParamMap::readJSON | ( | gx_system::JsonParser & | jp | ) |

## readJSON_one()

Parameter * gx_engine::ParamMap::readJSON_one | ( | gx_system::JsonParser & | jp | ) |

## reg_enum_par() [1/2]

FloatEnumParameter * gx_engine::ParamMap::reg_enum_par | ( | const string & | id,
|  | const string & | name,
|  | const value_pair * | vl,
|  | float * | var,
|  | int | std = 0,
|  | int | low = 0,
|  | bool | midi = true )

inline

Definition at line 610 of file gx_parameter.h.

## reg_enum_par() [2/2]

EnumParameter * gx_engine::ParamMap::reg_enum_par | ( | const string & | id,
|  | const string & | name,
|  | const value_pair * | vl,
|  | int * | var,
|  | int | std = 0,
|  | bool | midi = true )

inline

Definition at line 597 of file gx_parameter.h.

## reg_filepar()

FileParameter * gx_engine::ParamMap::reg_filepar | ( | const string & | id,
|  | bool | preset = false )

inline

Definition at line 644 of file gx_parameter.h.

## reg_non_midi_enum_par()

EnumParameter * gx_engine::ParamMap::reg_non_midi_enum_par | ( | const string & | id,
|  | const string & | name,
|  | const value_pair * | vl,
|  | int * | var,
|  | bool | preset,
|  | int | std = 0 )

inline

Definition at line 603 of file gx_parameter.h.

## reg_non_midi_par() [1/3]

BoolParameter * gx_engine::ParamMap::reg_non_midi_par | ( | const string & | id,
|  | bool * | var,
|  | bool | preset,
|  | bool | std = false )

inline

Definition at line 617 of file gx_parameter.h.

## reg_non_midi_par() [2/3]

FloatParameter * gx_engine::ParamMap::reg_non_midi_par | ( | const string & | id,
|  | float * | val,
|  | bool | preset,
|  | float | std = 0,
|  | float | lower = 0,
|  | float | upper = 1,
|  | float | step = 0 )

inline

Definition at line 638 of file gx_parameter.h.

## reg_non_midi_par() [3/3]

IntParameter * gx_engine::ParamMap::reg_non_midi_par | ( | const string & | id,
|  | int * | var,
|  | bool | preset,
|  | int | std,
|  | int | lower,
|  | int | upper )

inline

Definition at line 633 of file gx_parameter.h.

## reg_par() [1/5]

BoolParameter * gx_engine::ParamMap::reg_par | ( | const string & | id,
|  | const string & | name,
|  | bool * | var,
|  | bool | std = false,
|  | bool | preset = true,
|  | bool | midi = true )

inline

Definition at line 592 of file gx_parameter.h.

## reg_par() [2/5]

FloatParameter * gx_engine::ParamMap::reg_par | ( | const string & | id,
|  | const string & | name,
|  | float * | var,
|  | float | std,
|  | float | lower,
|  | float | upper,
|  | float | step,
|  | bool | midi = true )

inline

Definition at line 575 of file gx_parameter.h.

## reg_par() [3/5]

FloatParameter * gx_engine::ParamMap::reg_par | ( | const string & | id,
|  | const string & | name,
|  | float * | var,
|  | float | std = 0,
|  | bool | midi = true )

inline

Definition at line 587 of file gx_parameter.h.

## reg_par() [4/5]

IntParameter * gx_engine::ParamMap::reg_par | ( | const string & | id,
|  | const string & | name,
|  | int * | var,
|  | int | std,
|  | bool | midi )

inline

Definition at line 628 of file gx_parameter.h.

## reg_par() [5/5]

IntParameter * gx_engine::ParamMap::reg_par | ( | const string & | id,
|  | const string & | name,
|  | int * | var,
|  | int | std,
|  | int | lower,
|  | int | upper,
|  | bool | midi )

inline

Definition at line 622 of file gx_parameter.h.

## reg_par_non_preset()

FloatParameter * gx_engine::ParamMap::reg_par_non_preset | ( | const string & | id,
|  | const string & | name,
|  | float * | var,
|  | float | std,
|  | float | lower,
|  | float | upper,
|  | float | step )

inline

Definition at line 581 of file gx_parameter.h.

## reg_preset_string()

StringParameter * gx_engine::ParamMap::reg_preset_string | ( | const string & | id,
|  | const string & | name,
|  | Glib::ustring * | var,
|  | const string & | sv,
|  | bool | preset = true )

inline

Definition at line 654 of file gx_parameter.h.

## reg_string()

StringParameter * gx_engine::ParamMap::reg_string | ( | const string & | id,
|  | const string & | name,
|  | Glib::ustring * | var,
|  | const string & | sv,
|  | bool | preset = false )

inline

Definition at line 649 of file gx_parameter.h.

## reset_unit()

void gx_engine::ParamMap::reset_unit | ( | const PluginDef * | pdef | ) | const

## set_init_values()

void gx_engine::ParamMap::set_init_values | ( |  | ) |

## set_replace_mode()

void gx_engine::ParamMap::set_replace_mode | ( | bool | mode | ) |

inline

Definition at line 560 of file gx_parameter.h.

## signal_insert_remove()

sigc::signal< void, Parameter *, bool > gx_engine::ParamMap::signal_insert_remove | ( |  | ) |

inline

Definition at line 572 of file gx_parameter.h.

## unique_id()

void gx_engine::ParamMap::unique_id | ( | Parameter * | param | ) |

private

## unit_has_std_values()

bool gx_engine::ParamMap::unit_has_std_values | ( | const PluginDef * | pdef | ) | const

## unregister() [1/2]

void gx_engine::ParamMap::unregister | ( | const string & | id | ) |

## unregister() [2/2]

void gx_engine::ParamMap::unregister | ( | Parameter * | p | ) |

## writeJSON()

void gx_engine::ParamMap::writeJSON | ( | gx_system::JsonWriter & | jw | ) |

## writeJSON_one()

void gx_engine::ParamMap::writeJSON_one | ( | gx_system::JsonWriter & | jw,
|  | Parameter * | p )

## Friends And Related Symbol Documentation

## ParameterV

template<class T>

friend class ParameterV

friend

Definition at line 548 of file gx_parameter.h.

Referenced by ParameterV.

## Member Data Documentation

## id_map

map<string, Parameter*> gx_engine::ParamMap::id_map

private

Definition at line 537 of file gx_parameter.h.

Referenced by begin(), end(), hasId(), hasId(), operator[](), and operator[]().

## insert_remove

sigc::signal<void,Parameter*,bool> gx_engine::ParamMap::insert_remove

private

Definition at line 539 of file gx_parameter.h.

Referenced by signal_insert_remove().

## replace_mode

bool gx_engine::ParamMap::replace_mode

private

Definition at line 538 of file gx_parameter.h.

Referenced by reg_enum_par(), reg_non_midi_par(), reg_par(), reg_par(), reg_par_non_preset(), and set_replace_mode().

The documentation for this class was generated from the following file:

- src/headers/gx_parameter.h